<?php


/**
 * Klasse General
 * Zeigt algemeine Einstellungen von der isgw.conf Datei
 */

class remoteManagement {

	/*
	 * Funktion display erzeugt den Inhalt von der HTML-Seite
	 */
	function display($args) {
		// args
		$m = $_GET['m'];

		include('./includes/header.php');
		$remoteM_table = $this->dynamic_table();
		// build page content
		$ret .= "<br>" . $remoteM_table;

		//Rückgabe: Inhalt der HTML-Seite
		return $ret;
	}


	/*
	 * Der boolesche Wert von cloud_enable, der in der Datenbank gespeichert ist wird zurückgegeben
	 * in der Form eines Checkboxs und nachher angezeigt.
	 */
	function cloud_enable() {
		require_once( '/usr/fallback/beroConf.php' );
		$bc = new beroConf('root');
		$cloud_enable = $bc->get("root","cloud_enable");
		if($cloud_enable == "1")
			return "<input type='hidden' name='cloud_enable' value='0'>
					<input type='checkbox' name='cloud_enable' id='cloud_enable' value='1' checked>";
		else
			return "<input type='hidden' name='cloud_enable' value='0'>
					<input type='checkbox' name='cloud_enable' id='cloud_enable' value='1'>";

	}

        /*
	 * Der  Wert von cloudAddress, der in der Datenbank gespeichert ist, wird aus der DB geholt und
	 * in dem Formular als Textfeld und nachher angezeigt.
	 */
	function cloud_url() {
		$ba=new beroAri();
		$cloudAddress = $ba->get("cloudAddress");

		return "<input type='text' name='cloudAddress' id='cloudAddress' value='".$cloudAddress."'><input type='button' value='".BUTTON_LOAD_DEF."' onclick='load();'>";

	}
	/*
	 * Der boolesche Wert von snmp-enabled, der in der Datenbank gespeichert ist wird zurückgegeben
	 * in der Form eines Checkboxs und nachher angezeigt.
	 */
	function snmp_enabled() {
		require_once( '/usr/fallback/beroConf.php' );
		$bc = new beroConf('root');
		$snmp_enable = $bc->get("root","snmp-enabled");
		if($snmp_enable == "1")
			return "<input type='hidden' name='snmp_enabled' value='0'>
					<input type='checkbox' id='snmp_enable' onchange='snmp_show();' name='snmp_enabled' value='1' checked>";
		else
			return "<input type='hidden' name='snmp_enabled' value='0'>
					<input type='checkbox' id='snmp_enable' onchange='snmp_show();' name='snmp_enabled' value='1'>";

	}

	/*
	 * Der Wert von snmp-syslocation, der in der Datenbank gespeichert ist wird geholt
	 * und der Wert in einem Textfeld angezeigt.
	 */
	function snmp_syslocation () {
		require_once( '/usr/fallback/beroConf.php' );
		$bc = new beroConf('root');
		$snmp_syslocation = $bc->get('root', 'snmp-syslocation');
		return('<input type="text" name="snmp_syslocation" value="' . $snmp_syslocation . '" maxlength="255" />');

	}

        /*
	 * Der Wert von snmptraps, der in der Datenbank gespeichert ist wird geholt
	 * und gesplittet, die erlaubte Werte werden als Checkbox angezeigt, bei den
         * gespeicherten werden die Häckchen gesetzt.
	 */
	function snmptraps() {
		require_once( '/usr/fallback/beroConf.php' );
		$bc = new beroConf('root');
		$snmptraps = $bc->get("root","snmptraps");
                $snmptraps=explode (",",$snmptraps);
                //Wenn die Optionen mehr werden bitte auskommentieren
		//$res= "<fieldset>";
                if (in_array("snmptrap_isdnl2",$snmptraps)) $res.="<input type='checkbox' name='snmptraps' value='snmptrap_isdnl2' checked> ISDN-Layer 2";
                else $res.="<input type='checkbox' name='snmptraps' value='snmptrap_isdnl2'> ISDN-Layer 2";
                //$res.="</fieldset>";
		return $res;
	}

        /*
	 * Der Wert von snmptraps_sink, der in der Datenbank gespeichert ist wird geholt
	 * und der Wert in einem Textfeld angezeigt.
	 */
	function snmptraps_sink() {
		require_once( '/usr/fallback/beroConf.php' );
		$bc = new beroConf('root');
		$snmptraps_sink = $bc->get("root","snmptraps_sink");
		return "<input type='text' name='snmptraps_sink' value='".$snmptraps_sink."'> ";

	}

         /*
	 * Der Wert von snmptraps_intervall, der in der Datenbank gespeichert ist wird geholt
	 * und der Wert in einem Textfeld angezeigt.
	 */
	function snmptraps_intervall() {
		require_once( '/usr/fallback/beroConf.php' );
		$bc = new beroConf('root');
		$snmptraps_intervall = $bc->get("root","snmptraps_intervall");
		return "<input type='text' name='snmptraps_intervall' digits='true' required='true' value='".$snmptraps_intervall."'> ";

	}

        /*
	 * Der Wert von snmp-community-ro, der in der Datenbank gespeichert ist wird geholt
	 * und der Wert in einem Textfeld angezeigt.
	 */
	function ro_community() {
		require_once( '/usr/fallback/beroConf.php' );
		$bc = new beroConf('root');
		$ro_community = $bc->get("root","snmp-community-ro");
		return "<input type='text' name='snmp_community_ro' checkSnmp='true' value='".$ro_community."'> ";

	}

        /*
	 * Der Wert von snmp-community-rw, der in der Datenbank gespeichert ist wird geholt
	 * und der Wert in einem Textfeld angezeigt.
	 */
	function rw_community() {
		require_once( '/usr/fallback/beroConf.php' );
		$bc = new beroConf('root');
		$rw_community = $bc->get("root","snmp-community-rw");
		return "<input type='text' name='snmp_community_rw' checkSnmp='true' value='".$rw_community."'> ";

	}

        /*
	 * Der Wert von snmp-community-trap, der in der Datenbank gespeichert ist wird geholt
	 * und der Wert in einem Textfeld angezeigt.
	 */
	function community_trap() {
		require_once( '/usr/fallback/beroConf.php' );
		$bc = new beroConf('root');
		$community_trap = $bc->get("root","snmp-community-trap");
		return "<input type='text' name='snmp_community_trap' checkSnmp='true' value='".$community_trap."'> ";

	}

        /*
	 * Der boolesche Wert von proxyEnabled, der in der Datenbank gespeichert ist wird zurückgegeben
	 * in der Form eines Checkboxs und nachher angezeigt.
	 */
	function proxy_enable() {
		$ba=new beroAri();
		$proxy_enable = $ba->get("proxyEnabled");
		if($proxy_enable == "1")
			return "<input type='hidden' name='proxyEnabled' value='0'><input type='checkbox' name='proxyEnabled' id='proxyEnabled' value='1' checked>";
		else
			return "<input type='hidden' name='proxyEnabled' value='0'><input type='checkbox' name='proxyEnabled' id='proxyEnabled' value='1'>";

	}

        /*
	 * Der boolesche Wert von httpsOnly, der in der Datenbank gespeichert ist wird zurückgegeben
	 * in der Form eines Checkboxs und nachher angezeigt.
	 */
	function https_only() {
		$ba=new beroAri();
		$proxy_enable = $ba->get("httpsOnly");
		if($proxy_enable == "1")
			return "<input type='hidden' name='httpsOnly' value='0'><input type='checkbox' name='httpsOnly' value='1' checked>";
		else
			return "<input type='hidden' name='httpsOnly' value='0'><input type='checkbox' name='httpsOnly' value='1'>";

	}

	/*
	 * Die Cloud key, der in der Datenbank gespeichert ist wird zurückgegeben
	 * in der Form eines Textfelds und nachher angezeigt.
	 */
	function cloud_key() {
		require_once( '/usr/fallback/beroConf.php' );
		$bc = new beroConf('root');
		return $bc->get("root","cloud_key");
	}

        /*
	 * Das Proxytyp, das in der Datenbank gespeichert ist,
         * ein Selectbox wird zurückgegeben
	 */
	function proxy_type() {
		$ba=new beroAri();
                $proxyType=$ba->get("proxyType");
                $select="<select name='proxyType'>";
                ($proxyType=="CURLPROXY_HTTP") ? $select.="<option value='CURLPROXY_HTTP' selected>HTTP</option>" : $select.="<option value='CURLPROXY_HTTP'>HTTP</option>";
                ($proxyType=="CURLPROXY_SOCKS5") ? $select.="<option value='CURLPROXY_SOCKS5' selected>SOCKS5</option>" : $select.="<option value='CURLPROXY_SOCKS5'>SOCKS5</option>";
                $select.="</select>";
		return $select;
	}

        /*
     * Check, if a valid url is provided
     */

    function isDomainAvailable($url) {
        $connected = @fsockopen($url, 443); //website and port
        if ($connected) {
            $is_conn = true; //action when connected
            fclose($connected);
        } else {
            $is_conn = false; //action in connection failure
        }
        return $is_conn;
    }




	/*
	 * Funktion dynamic_table
	 */

	function dynamic_table() {
                $ba=new beroAri();
		require_once( '/usr/fallback/beroConf.php' );
		$result ="";
		//Wenn man Änderugen von der Daten macht werden die in der Tabelle der Datenbank
		//aktualisiert
		if (isset($_POST['cloud_enable'])) {

			$bc = new beroConf('root');
			$bc->set('root','cloud_enable',$_POST['cloud_enable']);
                        $ba->set("cloudAddress",sqlite_escape_string (trim($_POST['cloudAddress'])));

			if (isset($_POST['cloud_key'])) $bc->set('root','cloud_key',$_POST['cloud_key']);


                        $table.=Helper::activate(1,true,'remoteM',ACTIVATE);
		}
                if (isset($_POST['httpsOnly'])) {

			$ba->set('httpsOnly',$_POST['httpsOnly']);
                        $option=1;

                        $file_name= $_FILES["uploadfile"]["name"];
                        $tmp_file= $_FILES["uploadfile"]["tmp_name"];
                        if($_FILES["uploadfile"]["name"]!=""){
                            if($_FILES["uploadfile"]["size"]>51200) //50 kB
                            {
				$table.="<div class='center'><font color='red'>".HTTPS_FILE_SIZE_DIS."</font></div>";
                            }else{
                                exec('/usr/local/bin/openssl x509 -in '.$tmp_file.' -noout -text',$output,$ret);
                                if ($ret==0){
                                    @unlink("/usr/conf/berofix.pem");
                                    exec("/bin/cp ".$tmp_file." /usr/conf/berofix.pem");
                                    $option=3;
                                    $table.="<div class='center'><font color='red'>".SIP_GENERAL_UPLOAD_SUCCESS_DIS."</font></div>";
                                }else{
                                    $table.="<div class='center'><font color='red'>".HTTPS_INVALID_CERT_ERROR."</font></div>";
                                }
                            }
                        }
                        $table.=Helper::activate($option,true,'remoteM',ACTIVATE);
		}
		if (isset($_POST['snmp_enabled'])) {
			$bc = new beroConf('root');
			$bc->set('root','snmp-enabled',$_POST['snmp_enabled']);
                        if($_POST['snmp_enabled']==1){
                            $bc->set('root','snmptraps',sqlite_escape_string ($_POST['snmptraps']));
				$bc->set('root', 'snmp-syslocation', $_POST['snmp_syslocation']);
                            $bc->set('root','snmptraps_sink',sqlite_escape_string ($_POST['snmptraps_sink']));
                            $bc->set('root','snmptraps_intervall',sqlite_escape_string ($_POST['snmptraps_intervall']));
                            $bc->set('root','snmp-community-rw',sqlite_escape_string ($_POST['snmp_community_rw']));
                            $bc->set('root','snmp-community-ro',sqlite_escape_string ($_POST['snmp_community_ro']));
                            $bc->set('root','snmp-community-trap',sqlite_escape_string ($_POST['snmp_community_trap']));
                        }else{
                            $bc->set('root','snmptraps',"");
				$bc->set('root', 'snmp-syslocation', '');
                            $bc->set('root','snmptraps_sink',"");
                            $bc->set('root','snmptraps_intervall',"");
                            $bc->set('root','snmp-community-rw',"");
                            $bc->set('root','snmp-community-ro',"");
                            $bc->set('root','snmp-community-trap',"");
                        }

			$table.=Helper::activate(1,true,'remoteM',ACTIVATE);
		}
                if ($_POST['proxyEnabled']=='1' && isset($_POST['proxyAddress']) && isset($_POST['proxyPort']) && isset($_POST['proxyType'])){
                    $ba->set('proxyEnabled',sqlite_escape_string ($_POST['proxyEnabled']));
                    $ba->set('proxyAddress',sqlite_escape_string ($_POST['proxyAddress']));
                    $ba->set('proxyPort',sqlite_escape_string ($_POST['proxyPort']));
                    $ba->set('proxyType',sqlite_escape_string ($_POST['proxyType']));
                    $ba->set('proxyUser',sqlite_escape_string ($_POST['proxyUser']));
                    $ba->set('proxySecret',sqlite_escape_string ($_POST['proxySecret']));
                    $ba=new beroAri();
                    $table.=Helper::activate(1,true,'remoteM',ACTIVATE);
                }else if ($_POST['proxyEnabled']=='0'){
                    $ba->set('proxyEnabled',0);
                    $ba->set('proxyAddress',"");
                    $ba->set('proxyPort',"");
                    $ba->set('proxyType',"");
                    $ba->set('proxyUser',"");
                    $ba->set('proxySecret',"");
                    $ba=new beroAri();
                    $table.=Helper::activate(1,true,'remoteM',ACTIVATE);
                }
		if (isset($_POST['cloud_username']) && isset($_POST['cloud_password'])) {
                        $bc = new beroConf('root');
                        if (($bc->get('root','lan-nameserver')=="" || $bc->get('root','lan-gateway')=="") && $bc->get('root','lan-gateway')=="no") $result=CLOUD_NETWORK_HINT;
                        else if (!$this->isDomainAvailable($ba->get("cloudAddress"))) $result=CLOUD_NO_CONNECTION_HINT;
                        else{
                            $res=file_get_contents('/proc/cmdline');
                            preg_match("/[^a-zA-Z0-9=]*?d=(?<serial>.+) /",$res,$serial);
                            $serial=$serial['serial'];
                            $apiUrl='https://'.$ba->get("cloudAddress").'/index.php?r=api/register';
                            $ch = curl_init();

                            $data = array('serial'=>$serial, 'cloud_username'=>$_POST['cloud_username'], 'cloud_password'=>$_POST['cloud_password']);

                            curl_setopt($ch, CURLOPT_URL, $apiUrl);
                            curl_setopt($ch, CURLOPT_POST, 1);
                            curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
                            curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
                            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);

                            $result = curl_exec($ch);
                            preg_match("/[^a-zA-Z0-9=]*?yaqwsx(?<key>.+)yaqwsx/",$result,$key);
                            $key=unserialize($key['key']);
                            if (isset($key['key'])){
    				$bc = new beroConf('root');
				$bc->set('root','cloud_key',$key['key']);
				$table.=Helper::activate(1,true,'remoteM',ACTIVATE);
				$result=preg_replace("/[^a-zA-Z0-9=]*?yaqwsx(?<key>.+)yaqwsx/",". ",$result);
                            }
                            curl_close($ch);
                        }
		}

		require_once("./includes/lang.php");
		if ($result!="")  $table.="<div class='center'><font color='red'>".$result."</font><br/></div>";
		$table .= "
                    <script>
                    $(document).ready(function() {
                        snmp_show();
                    });
                    function load(){
                         $('#cloudAddress').val('berocloud.beronet.com');
                    }
                    function snmp_show(){
                    if( $('#snmp_enable').is(':checked') ){
                        $('#traps').show();
                        $('#sink').show();
                        $('#interval').show();
                        $('#communityRo').show();
                        $('#communityRw').show();
                        $('#communityTrap').show();
                    }else{
                        $('#traps').hide();
                        $('#sink').hide();
                        $('#interval').hide();
                        $('#communityRo').hide();
                        $('#communityRw').hide();
                        $('#communityTrap').hide();
                    }
                    }
                    </script>
                    <form class='extensions_form' action='' method='POST' autocomplete='off'>
					<input type=hidden name=m value=" . $_GET['m'] . ">
					<table class='contenttoc'>
					<tr>
					<th colspan='2'>".CLOUD_TABLE_HEADER_DIS."</th>
					</tr>
					<tr>
					<td><b>Cloud Username:</b></td>
					<!--<td><input type='text' name='register_key'></td>-->
					<td><input type='text' name='cloud_username'></td>
					</tr>
					<tr>
					<td><b>Cloud password:</b></td>
					<td><input type='password' name='cloud_password'></td>
					</tr>
					<tr>
					<td colspan='2' onmouseover=\"Tip('".CLOUD_NETWORK_HINT."')\" onmouseout='UnTip()'><input name='submit' type='submit' value='".BUTTON_REGISTER."'>
					</td>
					</tr>
					</table>
					</form>
					<br/>

					<form class='extensions_form' name='cloud' id='cloud' action='' method='POST'>
					<table class='contenttoc' id='table'>
					<tr>
					<td><b>".CLOUD_ENABLE_DIS.":</b></td>
					<td>" . $this->cloud_enable() . "</td>
					</tr>
                                        <tr>
					<td><b>".CLOUD_URL_DIS.":</b></td>
					<td>" . $this->cloud_url() . "</td>
					</tr>";
		if ($_SESSION['beroari_username']=="beroAdmin")
			$table.="<tr>
					<td><b>".CLOUD_KEY_DIS.":</b></td>
					<td><input type='text' name='cloud_key' value='" . $this->cloud_key() . "'></td>
					</tr>";

                        $table.="<tr>
					<td colspan='2'><input name='submit' type='submit' value='".BUTTON_SAVE."'>
					</td>
					</tr>
					</table>
					</form>
                                        <script>$(\"#cloud\").validate({
                                            rules: {
                                                cloudAddress: {
                                                    checkHostname: true,
                                                    required : '#cloud_enable:checked',
                                                },
                                            }
                                        }); </script>
					<br/>
                                        <form class='extensions_form' name='proxy' id='proxy' action='' method='POST'>
					<table class='contenttoc' id='table'>
                                        <tr>
					<th colspan='2'>".CLOUD_PROXY_SETTINGS."</th>
					</tr>
                                        <tr>
					<td><b>".CLOUD_PROXY_ENABLE.":</b></td>
					<td>".$this->proxy_enable()."</td>
					</tr>
					<tr>
					<td><b>".CLOUD_PROXY_ADDRESS.":</b></td>
					<td><input type='text' name='proxyAddress' value='".$ba->get('proxyAddress')."'></td>
					</tr>
                                        <tr>
					<td><b>".CLOUD_PROXY_PORT.":</b></td>
					<td><input type='text' name='proxyPort' value='".$ba->get('proxyPort')."'></td>
					</tr>
                                        <tr>
					<td><b>".CLOUD_PROXY_TYPE.":</b></td>
					<td>".$this->proxy_type()."</td>
					</tr>
                                        <tr>
					<td><b>".CLOUD_PROXY_USER.":</b></td>
					<td><input type='text' name='proxyUser' value='".$ba->get('proxyUser')."'></td>
					</tr>
                                        <tr>
					<td><b>".CLOUD_PROXY_SECRET.":</b></td>
					<td><input type='password' name='proxySecret'  value='".$ba->get('proxySecret')."'></td>
					</tr>
                                        <tr>
					<td colspan='2'><input name='submit' type='submit' value='".BUTTON_SAVE."'>
					</td>
					</tr>
					</table>
					</form>
                                        <script>$(\"#proxy\").validate({
                                            rules: {
                                                proxyAddress: {
                                                    required: '#proxyEnabled:checked',
                                                },
                                                proxyPort: {
                                                    required: '#proxyEnabled:checked',
                                                    digits: true,
                                                    range: [1,65535],
                                                },
                                            }
                                        }); </script>
					<br/>
					<form class='extensions_form' id='snmp' action='' method='POST'>
					<input type=hidden name=m value=" . $_GET['m'] . ">
					<table class='contenttoc'>
					<tr>
					<th colspan='2'>".SNMP_TABLE_HEADER_DIS."</th>
					</tr>
					<tr>
					<td><b>".SNMP_ENABLED_DIS.":</b></td>
					<td>" . $this->snmp_enabled() . "</td>
					</tr>
                                        <tr id='snmp_syslocation'>
					<td><b>" . SNMP_SYSLOCATION . ":</b></td>
					<td>" . $this->snmp_syslocation() . "</td>
					</tr>
                                        <tr id='traps'>
					<td><b>".SNMP_TRAPS_DIS.":</b></td>
					<td>" . $this->snmptraps() . "</td>
					</tr>
                                        <tr id='sink'>
					<td><b>".SNMP_TRAPS_SINK_DIS.":</b></td>
					<td>" . $this->snmptraps_sink() . "</td>
					</tr>
                                        <tr id='interval'>
					<td><b>".SNMP_TRAPS_INTERVALL_DIS.":</b></td>
					<td>" . $this->snmptraps_intervall() . "</td>
					</tr>
                                        <tr id='communityRo'>
					<td><b>".SNMP_RO_COMMUNITY_DIS.":</b></td>
					<td>" . $this->ro_community() . "</td>
					</tr>
                                        <tr id='communityRw'>
					<td><b>".SNMP_RW_COMMUNITY_DIS.":</b></td>
					<td>" . $this->rw_community() . "</td>
					</tr>
                                        <tr id='communityTrap'>
					<td><b>".SNMP_COMMUNITY_TRAP_DIS.":</b></td>
					<td>" . $this->community_trap() . "</td>
					</tr>
					<tr>
					<td colspan='2'><input name='submit' type='submit' value='".BUTTON_SAVE."'>
					</td>
					</tr>";
					if (is_file("/usr/local/conf/BEROFIX-MIB.txt"))
					$table .="<tr>
					<td colspan='2'><a href=\"misc/files_download.php?option=BEROFIX-MIB\">Download BEROFIX-MIB</a></td>
					</tr>";
					$table .= "</table>
					</form>
                                        <script>$(\"#snmp\").validate(); </script>
                                        <br/>
					<form class='extensions_form' ENCTYPE=\"multipart/form-data\" action='' method='POST'>
					<input type=hidden name=m value=" . $_GET['m'] . ">
					<table class='contenttoc'>
					<tr>
					<th colspan='2'>".HTTPS_TABLE_HEADER_DIS."</th>
					</tr>
					<tr>
					<td><b>".HTTPS_UPLOAD_CERTIFICATE_DIS.":</b></td>
					<td nowrap><input type='file' size='28' name='uploadfile'></td>
					</tr>";
					if (file_exists("/usr/conf/berofix.pem") && !is_link("/usr/conf/berofix.pem")){
                                        $table .= "<tr>
					<td><b>".HTTPS_CERTIFICATE_DIS.":</b></td>
					<td><input type='button' value='".HTTPS_DOWNLOAD_CERTIFICATE_DIS."' onclick=\" window.location.href='misc/files_download.php?option=certificate_https';\">&nbsp;&nbsp;
					<input type='button' value='".HTTPS_DELETE_CERTIFICATE_DIS."' onclick=\"javascript:if (confirm('".HTTPS_DELETE_CERTIFICATE_MESS_DIS."?')==true) window.location.href='misc/deletedatei.php?option=certificate_https';\"></td>
					</tr>";
                                        }
					$table .="<tr>
					<td><b>".HTTPS_ONLY_DIS.":</b></td>
					<td>".$this->https_only()."</td>
					</tr>
                                        <tr>
					<td colspan='2'><input name='submit' type='submit' value='".BUTTON_SAVE."'>
					</td>
					</tr>";
					$table .= "</table>
					</form>";
		//Rückgabe: Erzeugte Tabelle mit den änderbaren Feldern von den Einstellungen von isgw.conf
		return $table;
	}

}
?>
